Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package symtab
  Definition Classes
    nsc
-  package classfile
  Definition Classes
    symtab
- AbstractFileReader
- ClassfileParser
- Pickler

c

scala.tools.nsc.symtab.classfile

# ClassfileParser 

###

#### abstract class ClassfileParser extends AnyRef

This abstract class implements a class file parser.

Source
  ClassfileParser.scala
Version

  1.0

Linear Supertypes
AnyRef, Any
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ClassfileParser
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new ClassfileParser()

### Type Members

1.  class ConstantPool extends AnyRef

   Constructor of this class should not be called directly, use `newConstantPool` instead.

   Constructor of this class should not be called directly, use `newConstantPool` instead.

   Attributes
     protected
2.  case class InnerClassEntry (external: Int, outer: Int, name: Int, jflags: JavaAccFlags) extends Product with Serializable

   An entry in the InnerClasses attribute of this class file.

3.  class LazyAliasType extends (symbolTable)#LazyType with (symbolTable)#FlagAgnosticCompleter
4.  abstract type ThisConstantPool <: ConstantPool
   Attributes
     protected
5.  class TypeParamsType extends (symbolTable)#LazyType with (symbolTable)#FlagAgnosticCompleter

### Abstract Value Members

1.  abstract def classPath: ClassPath

   The compiler classpath.

2.  abstract val loaders: SymbolLoaders { val symbolTable: scala.tools.nsc.symtab.classfile.ClassfileParser.<refinement>.type }
3.  abstract def lookupMemberAtTyperPhaseIfPossible(sym: (symbolTable)#Symbol, name: (symbolTable)#Name): (symbolTable)#Symbol

   If typer phase is defined then perform member lookup of a symbol `sym` at typer phase.

   If typer phase is defined then perform member lookup of a symbol `sym` at typer phase. This method results from refactoring. The original author of the logic that uses typer phase didn't explain why we need to force infos at that phase specifically. It only mentioned that ClassfileParse can be called late (e.g. at flatten phase) and we make to make sure we handle such situation properly.

   Attributes
     protected
4.  abstract def newConstantPool: ThisConstantPool
   Attributes
     protected
5.  abstract val symbolTable: SymbolTable { def settings: scala.tools.nsc.Settings }

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from ClassfileParser to any2stringadd[ClassfileParser] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (ClassfileParser, B)
   Implicit
     This member is added by an implicit conversion from ClassfileParser to ArrowAssoc[ClassfileParser] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  def addEnclosingTParams(clazz: (symbolTable)#Symbol): Unit

   Add type parameters of enclosing classes

7.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
8.  var busy: (symbolTable)#Symbol
   Attributes
     protected
9.  def classNameToSymbol(name: (symbolTable)#Name): (symbolTable)#Symbol

   Return the class symbol of the given name.

10.  var classTParams: Map[(symbolTable)#Name, (symbolTable)#Symbol]
    Attributes
      protected
11.  var clazz: (symbolTable)#ClassSymbol
    Attributes
      protected
12.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
13.  var currentClass: (symbolTable)#Name
    Attributes
      protected
14.  def ensuring(cond: (ClassfileParser) ⇒ Boolean, msg: ⇒ Any): ClassfileParser
    Implicit
      This member is added by an implicit conversion from ClassfileParser to Ensuring[ClassfileParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: (ClassfileParser) ⇒ Boolean): ClassfileParser
    Implicit
      This member is added by an implicit conversion from ClassfileParser to Ensuring[ClassfileParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: Boolean, msg: ⇒ Any): ClassfileParser
    Implicit
      This member is added by an implicit conversion from ClassfileParser to Ensuring[ClassfileParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: Boolean): ClassfileParser
    Implicit
      This member is added by an implicit conversion from ClassfileParser to Ensuring[ClassfileParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
19.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
20.  var file: AbstractFile
    Attributes
      protected
21.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
22.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from ClassfileParser to StringFormat[ClassfileParser] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
23.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
24.  def getScope(flags: JavaAccFlags): (symbolTable)#Scope
    Attributes
      protected
25.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
26.  var in: AbstractFileReader
    Attributes
      protected
27.  var instanceScope: (symbolTable)#Scope
    Attributes
      protected
28.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
29.  var isScala: Boolean
    Attributes
      protected
30.  var isScalaAnnot: Boolean
    Attributes
      protected
31.  var isScalaRaw: Boolean
    Attributes
      protected
32.  def moduleClass: (symbolTable)#Symbol
    Attributes
      protected
33.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
34.  final def notify(): Unit
    Definition Classes
      AnyRef
35.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
36.  def parse(file: AbstractFile, clazz: (symbolTable)#ClassSymbol, module: (symbolTable)#ModuleSymbol): Unit

    `clazz` and `module` are the class and module symbols corresponding to the classfile being parsed.

    `clazz` and `module` are the class and module symbols corresponding to the classfile being parsed. Note that the ClassfileLoader unconditionally creates both of these symbols, they may may get invalidated later on (.exists).

    Note that using `companionModule` / `companionClass` does not always work to navigate between those two symbols, namely when they are shadowed by a type / value in the a package object (scala-dev#248).

37.  def parseAttributes(sym: (symbolTable)#Symbol, symtype: (symbolTable)#Type, removedOuterParameter: Boolean = false): Unit
38.  def parseClass(): Unit
39.  def parseField(): Unit
40.  def parseInnerClasses(): Unit

    Parse inner classes.

    Parse inner classes. Expects `in.bp` to point to the superclass entry. Restores the old `bp`.

41.  def parseMethod(): Unit
42.  var pool: ThisConstantPool
    Attributes
      protected
43.  final def s1(): Int
    Attributes
      protected
44.  final def s2(): Int
    Attributes
      protected
45.  def skipAttributes(): Unit
46.  def skipMembers(): Unit
47.  def skipSuperclasses(): Unit
48.  def srcfile: Option[AbstractFile]
49.  var srcfile0: Option[AbstractFile]
    Attributes
      protected
50.  var staticModule: (symbolTable)#ModuleSymbol
    Attributes
      protected
51.  var staticScope: (symbolTable)#Scope
    Attributes
      protected
52.  def stubClassSymbol(name: (symbolTable)#Name): (symbolTable)#Symbol
53.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
54.  def toString(): String
    Definition Classes
      AnyRef → Any
55.  final def u1(): Int
    Attributes
      protected
56.  final def u2(): Int
    Attributes
      protected
57.  final def u4(): Int
    Attributes
      protected
58.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
59.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
60.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
61.  def →[B](y: B): (ClassfileParser, B)
    Implicit
      This member is added by an implicit conversion from ClassfileParser to ArrowAssoc[ClassfileParser] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc
62.  object innerClasses

    Return the class symbol for the given name.

    Return the class symbol for the given name. It looks it up in its outer class. Forces all outer class symbols to be completed.

    If the given name is not an inner class, it returns the symbol found in `definitions`.

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ClassfileParser to any2stringadd[ClassfileParser]

### Inherited by implicit conversion StringFormat from ClassfileParser to StringFormat[ClassfileParser]

### Inherited by implicit conversion Ensuring from ClassfileParser to Ensuring[ClassfileParser]

### Inherited by implicit conversion ArrowAssoc from ClassfileParser to ArrowAssoc[ClassfileParser]

### Ungrouped